/*****************************************************
This program was produced by the
CodeWizardAVR V2.03.4 Standard
Automatic Program Generator

Chip type           : ATtiny13
Clock frequency     : 4,800000 MHz
Memory model        : Tiny
External RAM size   : 0
Data Stack size     : 16
*****************************************************/

#include <tiny13.h>
#include <delay.h>

int mode;
#define MAX_MODE 5

// Declare your global variables here

void main(void)
{
// Declare your local variables here

// Crystal Oscillator division factor: 1
#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

// Input/Output Ports initialization
// Port B initialization
// Func5=Out Func4=In Func3=In Func2=In Func1=In Func0=Out 
// State5=0 State4=T State3=T State2=P State1=T State0=0 
PORTB=0x04;
DDRB=0x21;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
// Mode: Normal top=FFh
// OC0A output: Disconnected
// OC0B output: Disconnected
TCCR0A=0x00;
TCCR0B=0x00;
TCNT0=0x00;
OCR0A=0x00;
OCR0B=0x00;

// External Interrupt(s) initialization
// INT0: Off
// Interrupt on any change on pins PCINT0-5: Off
GIMSK=0x00;
MCUCR=0x00;

// Timer/Counter 0 Interrupt(s) initialization
TIMSK0=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
ACSR=0x80;
ADCSRB=0x00;

mode = 0;

//   2    
PORTB.0 = 1;
delay_ms(500);
PORTB.0 = 0;
delay_ms(500);
PORTB.0 = 1;
delay_ms(500);
PORTB.0 = 0;
delay_ms(500);

while (1)
      {
          switch (mode)
          {
          case 0:
              PORTB.5 = 1;                
              delay_ms(1);                  
              PORTB.5 = 0;                  
              delay_ms(8);
              break;
          case 1:
              PORTB.5 = 1;                
              delay_ms(1);                  
              PORTB.5 = 0;                  
              delay_ms(10);
              break;
          case 2:
              PORTB.5 = 1;                
              delay_ms(1);                  
              PORTB.5 = 0;                  
              delay_ms(12);
              break;
          case 3:
              PORTB.5 = 1;                
              delay_ms(1);                  
              PORTB.5 = 0;                  
              delay_ms(14);
              break;
          case 4:
              PORTB.5 = 1;                
              delay_ms(1);                  
              PORTB.5 = 0;                  
              delay_ms(20);
              break;
          }
          
          //  
          if (PINB.2 == 0)
          {
              int i;
             
              while (PINB.2 == 0) delay_ms(50);   //   
              mode++;
              
              if (mode == MAX_MODE)
                  mode = 0;
                  
              //     
              for(i=0; i<=mode; i++)
              {
                PORTB.0 = 1;
                delay_ms(300);
                PORTB.0 = 0;
                delay_ms(100);
              } 
          }
          
      };
}
