
#pragma used+
sfrb ADCSRB=0x03;
sfrb ADCL=0x04;
sfrb ADCH=0x05;
sfrw ADCW=0x04; 
sfrb ADCSRA=0x06;
sfrb ADMUX=0x07;
sfrb ACSR=0x08;
sfrb DIDR0=0x14;
sfrb PCMSK=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEAR=0x1e;
sfrb WDTCR=0x21;
sfrb CLKPR=0x26;
sfrb GTCCR=0x28;
sfrb OCR0B=0x29;
sfrb DWDR=0x2e;
sfrb TCCR0A=0x2f;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0B=0x33;
sfrb MCUSR=0x34;
sfrb MCUCR=0x35;
sfrb OCR0A=0x36;
sfrb SPMCSR=0x37;
sfrb TIFR0=0x38;
sfrb TIMSK0=0x39;
sfrb GIFR=0x3a;
sfrb GIMSK=0x3b;
sfrb SPL=0x3d;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x18
	.EQU __sm_adc_noise_red=0x08
	.EQU __sm_powerdown=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm

#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

int mode;

void main(void)
{

#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;
#pragma optsize+

PORTB=0x04;
DDRB=0x21;

TCCR0A=0x00;
TCCR0B=0x00;
TCNT0=0x00;
OCR0A=0x00;
OCR0B=0x00;

GIMSK=0x00;
MCUCR=0x00;

TIMSK0=0x00;

ACSR=0x80;
ADCSRB=0x00;

mode = 0;

PORTB.0 = 1;
delay_ms(500);
PORTB.0 = 0;
delay_ms(500);
PORTB.0 = 1;
delay_ms(500);
PORTB.0 = 0;
delay_ms(500);

while (1)
{
switch (mode)
{
case 0:
PORTB.5 = 1;                
delay_ms(1);                  
PORTB.5 = 0;                  
delay_ms(8);
break;
case 1:
PORTB.5 = 1;                
delay_ms(1);                  
PORTB.5 = 0;                  
delay_ms(10);
break;
case 2:
PORTB.5 = 1;                
delay_ms(1);                  
PORTB.5 = 0;                  
delay_ms(12);
break;
case 3:
PORTB.5 = 1;                
delay_ms(1);                  
PORTB.5 = 0;                  
delay_ms(14);
break;
case 4:
PORTB.5 = 1;                
delay_ms(1);                  
PORTB.5 = 0;                  
delay_ms(20);
break;
}

if (PINB.2 == 0)
{
int i;

while (PINB.2 == 0) delay_ms(50);   
mode++;

if (mode == 5)
mode = 0;

for(i=0; i<=mode; i++)
{
PORTB.0 = 1;
delay_ms(300);
PORTB.0 = 0;
delay_ms(100);
} 
}

};
}
